<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Clientes_model extends CI_Model {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->driver('cache', array('adapter' => 'file', 'key_prefix' => 'ata_'));
	}

	public function get_cliente(){
		$idpersona = $this->input->post('idpersona');

		$this->db->from('lista_clientes');
		$this->db->where('idpersona', $idpersona);

		$query = $this->db->get();

		return $query->result();
	}

	public function buscar_cliente($hint='')
	{
		$this->db->select("idcliente, apellidop, apellidom, nombres");
		$this->db->from('lista_clientes');

		$wildcarded_hint = '%'.$hint.'%';

		$this->db->where('nombres LIKE', $wildcarded_hint);
		$this->db->or_where('apellidop LIKE', $wildcarded_hint);
		$this->db->or_where('apellidom LIKE', $wildcarded_hint);
		
		$query = $this->db->get();

		return $query->result();
	}

	public function nuevo_cliente()
	{
		$nombres = $this->input->post('nombres');
		$appaterno = $this->input->post('appaterno');
		$apmaterno = $this->input->post('apmaterno');
		$email = $this->input->post('email');
		$telfijo = $this->input->post('telfijo');
		$telcel = $this->input->post('telcel');
		$rfc = $this->input->post('rfc');
		$razonsocial = $this->input->post('razonsocial');
		$calle = $this->input->post('calle');
		$nint = $this->input->post('nint');
		$next = $this->input->post('next');
		$estado = $this->input->post('estado');
		$municipio = $this->input->post('municipio');
		$localidad = $this->input->post('localidad');

		$curp = $this->input->post('curp');
		$claveife = $this->input->post('claveife');

		$persona = array(
			'nombres' => $nombres,
			'apellidop' => $appaterno,
			'apellidom' => $apmaterno,
			'telefono' => $telfijo,
			'celular' => $telcel,
			'correo' => $email,
			'calle' => $calle,
			'numint' => $nint,
			'numext' => $next,
			'municipio' => $municipio,
			'localidad' => $localidad,
			'estado' => $estado,
			'rfc' => $rfc,
			'razonsocial' => $razonsocial
			);

		$this->db->insert('personas', $persona);

		$idpersona = $this->db->insert_id();

		$cliente = array(
			'persona' => $idpersona,
			'curp' => $curp,
			'claveife' => $claveife
			);

		return $this->db->insert('clientes', $cliente);
	}

	public function editar_cliente(){
		$idpersona = $this->input->post('idpersona');
		$nombres = $this->input->post('nombres');
		$appaterno = $this->input->post('appaterno');
		$apmaterno = $this->input->post('apmaterno');
		$email = $this->input->post('email');
		$telfijo = $this->input->post('telfijo');
		$telcel = $this->input->post('telcel');
		$rfc = $this->input->post('rfc');
		$razonsocial = $this->input->post('razonsocial');
		$calle = $this->input->post('calle');
		$nint = $this->input->post('nint');
		$next = $this->input->post('next');
		$estado = $this->input->post('estado');
		$municipio = $this->input->post('municipio');
		$localidad = $this->input->post('localidad');

		$idcliente = $this->input->post('idcliente');
		$curp = $this->input->post('curp');
		$claveife = $this->input->post('claveife');

		$persona = array(
			'nombres' => $nombres,
			'apellidop' => $appaterno,
			'apellidom' => $apmaterno,
			'telefono' => $telfijo,
			'celular' => $telcel,
			'correo' => $email,
			'calle' => $calle,
			'numint' => $nint,
			'numext' => $next,
			'municipio' => $municipio,
			'localidad' => $localidad,
			'estado' => $estado,
			'rfc' => $rfc,
			'razonsocial' => $razonsocial
			);

		$this->db->where('idpersona', $idpersona);
		$this->db->update('personas', $persona);


		$cliente = array(
			'curp' => $curp,
			'claveife' => $claveife
			);

		$this->db->where('idcliente', $idcliente);
		return $this->db->replace('clientes', $cliente);
	}

	public function eliminar_cliente($id){
		$data=$this->db->get_where('clientes', array('idcliente'=>$id));
		$data=array('activo'=>0);
		return $this->db->update('clientes',$data,array('idcliente'=>$id));
		
	}

	public function listado_clientes($offset = 0, $limit = 2){
		$this->db->from('lista_clientes');
		$this->db->select('idpersona, idcliente, nombres, apellidop, apellidom, correo');

		$this->db->limit($limit, $offset);

		$query = $this->db->get();

		return $query->result();
	}

	public function cliente_autocomplete($cadena='')
	{
		$this->db->select('idcliente, nombres');
		$this->db->from('lista_clientes');
		$this->db->where('nombres like', $cadena);
		$this->db->limit(5);
		$this->db->order_by('nombres', 'desc');

		$query = $this->db->get();

		return $query->result();
	}
}

/* End of file  */
/* Location: ./application/models/ */