<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Contenido_model extends CI_Model {

	public function __construct()
	{
		parent::__construct();
		$this->load->database();
		$this->load->library('session');
		$this->load->driver('cache', array('adapter' => 'file', 'key_prefix' => 'ata_'));
	}

	public function carga_informacion(){
		$nombre 	= $this->input->post('nombre');
		$codigo 	= $this->input->post('codigo');
		$materia 	= $this->input->post('materia');
		$tema 		= $this->input->post('tema');
		$subtema 	= $this->input->post('subtema');
		$contenido 	= $this->input->post('contenido');

		$texto = array(
			'idcodigo' 	=> $codigo,
			'idmateria' => $materia,
			'idtema' 	=> $tema,
			'idsubtema' => $subtema,
			'titulo' 	=> $nombre,
			'contenido' => $contenido,
			'idabogado' => $this->session->userdata('consultor_idabogado')
			);

		return $this->db->insert('textos', $texto);
	}

	public function carga_batch($leyes)
	{
		return $this->db->insert_batch('textos', $leyes, TRUE);
		// SELECT materias.idmateria, materias.nombre, temas.idtema, temas.nombre, subtemas.idsubtema, subtemas.nombre FROM materias JOIN temas on materias.idmateria = temas.idmateria JOIN subtemas ON temas.idtema = subtemas.idtema WHERE materias.codigo = ''
	}

	public function listado_informacion($offset = 0, $limit = 2){
		$this->db->from('textos');
		$this->db->select('idtexto as id, idcodigo as codigo, idmateria as materia, idtema as tema, idsubtema as subtema, titulo as nombre');
		$this->db->limit($limit, $offset);

		$query = $this->db->get();

		return $query->result_array();
	}

	function modifica_informacion(){
		$nombre 	= $this->input->post('nombre');
		$codigo 	= $this->input->post('codigo');
		$materia 	= $this->input->post('materia');
		$tema 		= $this->input->post('tema');
		$subtema 	= $this->input->post('subtema');
		$contenido 	= $this->input->post('contenido');
		$id			= $this->input->post('id');

		$texto = array(
			'idtexto'	=> $id,
			'idcodigo' 	=> $codigo,
			'idmateria' => $materia,
			'idtema' 	=> $tema,
			'idsubtema' => $subtema,
			'titulo' 	=> $nombre,
			'contenido' => $contenido,
			'idabogado' => $this->session->userdata('consultor_idabogado')
			);

		return (null!=$this->session->userdata('consultor_idabogado')) ? $this->db->replace('textos', $texto) : false;
	}

	public function busca_informacion($materia = '', $tema = '', $subtema = '', $palabras = array(), $operadores = array()){
		
		// $signos_booleanos = array('or' => '' ,
		// 	'and' => '+',
		// 	'not' => '-');

		// $condiciones = '';

		// foreach ($palabras as $idpalabra => $palabra) {
		// 	if($this->is_null_or_empty_string($palabra))
		// 		continue;

		// 	$condiciones .= $signos_booleanos[$operadores[$idpalabra]] . $palabra . ' ';
		// }

		// $boolean_search = "WHERE MATCH (titulo,contenido) AGAINST ('".$condiciones."' IN BOOLEAN MODE)";

		// $category_search = '';

		// if (!$this->is_null_or_empty_string($subtema)) {
		// 	$category_search = ' AND  idsubtema = '.$subtema;
		// } else if (!$this->is_null_or_empty_string($tema)) {
		// 	$category_search = ' AND idtema = '.$tema;
		// } else if (!$this->is_null_or_empty_string($materia)) {
		// 	$category_search = ' AND idmateria = '.$materia;
		// }

		// $category_search = (!$this->is_null_or_empty_string($category_search)) ? $category_search : '';
		
		//$query_text = "SELECT idtexto, titulo, contenido FROM textos ".$boolean_search.$category_search;
		
		// $query = $this->db->query($query_text);

		$this->db->select('idtexto, titulo, contenido, codigos.idjurisdiccion as estado, codigos.idcodigo');
		$this->db->from('textos');
		$this->db->join('codigos', 'codigos.idcodigo = textos.idcodigo', 'right');

		if (!$this->is_null_or_empty_string($subtema)) {
			$this->db->where('idsubtema', $subtema);
		} 

		if (!$this->is_null_or_empty_string($tema)) {
			$this->db->where('idtema', $tema);
		}

		if (!$this->is_null_or_empty_string($materia)) {
			$this->db->where('idmateria', $materia);
		}

		$query = $this->db->get();

		return $query->result();
		//return $query_text;
	}

	public function elimina_informacion(){
		$id = $this->input->post('id');

		if (!$this->is_null_or_empty_string($id)) {
			if ($this->db->delete('textos', array('idtexto' => $id)) === FALSE) {
				return FALSE;
			} else {
				return TRUE;
			}
			return ;	
		} else {
			return FALSE;
		}
	}

	function get_texto_from_db($id = ''){

		$this->db->from('textos');
		$this->db->join('codigos', 'codigos.idcodigo = textos.idcodigo');
		$this->db->select('idtexto as id, textos.idcodigo as codigo, codigos.idjurisdiccion as estado, idmateria as materia, idtema as tema, idsubtema as subtema, titulo as nombre, contenido as contenido');
		$this->db->where('idtexto=', $id);

		return $this->db->get();
	}

	public function leer_categorias($reload = FALSE){
		if(!$this->cache->file->is_supported() or $this->cache->get('categorias') == FALSE or $reload){

			$this->db->select('idjurisdiccion as id, entidadfederativa as nombre');
			$this->db->from('jurisdicciones');
			$estados = $this->db->get()->result_array();

			$this->db->select('idcodigo as id, idjurisdiccion as idparent, nombre');
			$this->db->from('codigos');
			$codigos = $this->db->get()->result_array();

			$this->db->select('idmateria as id, nombre');
			$this->db->from('materias');
			$materias = $this->db->get()->result_array();

			$this->db->select('idtema as id, idmateria as idparent, nombre');
			$this->db->from('temas');
			$temas = $this->db->get()->result_array();

			$this->db->select('idsubtema as id, idtema as idparent, nombre');
			$this->db->from('subtemas');
			$subtemas = $this->db->get()->result_array();

			$categorias = array(
				'estados'	=> $estados,
				'codigos' 	=> $codigos,
				'materias' 	=> $materias,
				'temas' 	=> $temas,
				'subtemas' 	=> $subtemas
				);

			if($this->cache->file->is_supported())
				$this->cache->save('categorias', $categorias, 86400);

			return $categorias;

		} else {
			return $this->cache->get('categorias');
		}
	}

	public function codigo_a_ids(&$codigo)
	{
		$materia = $codigo->getMateria();
		$tema = $codigo->getTema();
		$subtemas = $codigo->getSubtemas();

		
		$this->db->select('materias.idmateria, materias.nombre as materia, temas.idtema, temas.nombre as tema, subtemas.idsubtema, subtemas.nombre as subtema, subtemas.codigo as codigo');
		$this->db->from('materias');
		$this->db->join('temas', 'materias.idmateria = temas.idmateria', 'left');
		$this->db->join('subtemas', 'temas.idtema = subtemas.idtema', 'left');
		$this->db->where('materias.codigo', $materia['codigo']);
		$this->db->where('temas.codigo', $tema['codigo']);
		foreach ($subtemas as $subtema) {
			$wherein[] = $subtema['codigo'];
		}
		$this->db->where_in('subtemas.codigo', $wherein);
		//$this->db->where('subtemas.codigo', $subtemas[0]['codigo']);

		//die($this->db->get_compiled_select());

		$results = $this->db->get()->result_array();

		$first_result = $results[0];

		$materia['id'] = $first_result['idmateria'];
		$materia['nombre'] = $first_result['materia'];
		$tema['id'] = $first_result['idtema'];
		$tema['nombre'] = $first_result['tema'];

		$subtemas = array();

		foreach ($results as $result) {
			$subtema['id'] = $result['idsubtema'];
			$subtema['nombre'] = $result['subtema'];
			$subtema['codigo'] = $result['codigo'];
			$subtemas[] = $subtema;
		}

		$codigo->setMateria($materia);
		$codigo->setTema($tema);
		$codigo->setSubtemas($subtemas);
	}

	function get_categorias_array(){
		if(!$this->cache->file->is_supported() or $this->cache->get('categorias_array') == FALSE){
			$big_array = array();
			foreach ($this->leer_categorias(TRUE) as $cat_name => $categoria) {
				$array = array();
				foreach ($categoria as $item) {
					$array[$item['id']] = $this->mb_ucfirst($item['nombre']);
				}

				$big_array[$cat_name] = $array;
			}

			return $big_array;
		} else {
			return $this->cache->get('categorias_array');
		}
	}

	function mb_ucfirst($str, $to_lower = false, $charset = 'utf-8')
		{
			$first = mb_strtoupper(mb_substr($str, 0, 1, $charset), $charset);
			$end = mb_substr($str, 1, mb_strlen($str, $charset), $charset);
			// Convert them all to lowercase (if specified)
			if ( $to_lower ) {
				$end = mb_strtolower($end, $charset);
			}
			return $first . $end;
		}

	function is_null_or_empty_string($question){
    	return (!isset($question) || trim($question)==='' || trim($question)==='empty');
	}
}

/* End of file contenido_model.php */
/* Location: ./application/models/contenido_model.php */