$('#nombres').autocomplete({
	serviceUrl: base_url() + 'consultor/cliente_autocomplete',
	onSelect: function (suggestion) {
		$('#idcliente').val(suggestion.data);
	}
});

$( window ).load(function loadComboData()
{
	GetComboData('', 'consulta-materia', 'materias', true);
	tooltips();
});

function tooltips () {
	$(function () {
		$('[data-toggle="tooltip"]').tooltip()
	});
}

$('#fecha-apertura').datetimepicker({
	format: 'YYYY/MM/D',
	locale: 'es'
});

$('#consulta-fecha-group').datetimepicker({
	format: 'YYYY/MM/D',
	locale: 'es'
});

$('#md-editar-caso').on('show.bs.modal', function(event) {
	jQuery.ajaxSetup({async: false});

	var mode = $(event.relatedTarget).data('mode');

	$('#fechaapertura').val('');
	$('#nombres').val('');
	$('#expedientelegal').val('');
	$('#sinopsis').val('');
	$('#idcaso').val('');
	$('#idcliente').val('');

	if (mode == 'edit') {
		var idCaso = $(event.relatedTarget).data('cid');

		$.ajax({
			url: base_url() + 'consultor/leer-caso',
			type: 'POST',
			dataType: 'json',
			data: {idcaso: idCaso},
		})
		.done(function(response) {
			casoData = response[0];

			$('#fechaapertura').val(casoData.fechaapertura);
			$('#idcaso').val(casoData.idcaso);
			$('#idcliente').val(casoData.idcliente);
			$('#nombres').val(casoData.apellidop+' '+casoData.apellidom+', '+ casoData.nombres);
			$('#expedientelegal').val(casoData.expedientelegal);
			$('#sinopsis').val(casoData.sinopsis);
		})
		.fail(function() {
			console.log("error");
		})
		.always(function() {
			console.log("complete");
		});


	};

	jQuery.ajaxSetup({async: true});
});


$('#frm-editar-caso').on('submit', function() {
	var formData = $('#frm-editar-caso').serializeArray();

	var idCaso = $('#idcaso').val();

	var formURL = 'consultor/guardar-caso';

	if (idCaso == '') {
		formURL = 'consultor/nuevo-caso';
	}	

	$.ajax({
		url: base_url() + formURL,
		type: 'POST',
		dataType: 'json',
		data: formData,
	})
	.done(function() {
		$('#frm-editar-caso').modal('hide');
		location.reload();
	})
	.fail(function() {
		console.log("error");
	})
	.always(function() {
		console.log("complete");
	});


	return false;
});

function leer_consultas(idCaso){
	$('#md-nueva-consulta').data('idcaso', idCaso);
	$.ajax({
		url: base_url() + 'consultor/consultas-de-caso',
		type: 'POST',
		dataType: 'json',
		data: {idcaso: idCaso},
	})
	.done(function(response) {

		var tableHTML = '';

		$.each(response, function(index, consulta) {
			tableHTML += 	
			'<tr><td>' + consulta.contenido.substring(0, 137) + '...' +
			'</td><td>' + consulta.fecha +
			'</td><td>' + consulta.materia +
			'</td><td>' + consulta.tema +
			'</td><td>' + consulta.subtema +
			'</td><td><a class="btn btn-primary btn-sm" href="'+ base_url() + 'consultor/consultas/responder/' + consulta.idconsulta +'" role="button" data-toggle="tooltip" data-placement="top" title="Responder consulta"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> </a>'+
			'<a class="btn btn-info btn-sm" href="'+ base_url() + 'reportes/reporte-consulta/imprimir/' + consulta.idconsulta +'" role="button" data-toggle="tooltip" data-placement="top" title="Imprimir consulta"><span class="glyphicon glyphicon-print" aria-hidden="true"></span> </a>'+
			'</td></tr>';
		});

		$("#tabla-casos tr").not(':first').remove();
		$('#tabla-casos').append(tableHTML);
		tooltips();

	})
	.fail(function() {
		console.log("error");
	})
	.always(function() {
		console.log("complete");
	});
}

$('#md-consultas-de-caso').on('show.bs.modal', function(event) {
	var idCaso = $(event.relatedTarget).data('cid');
	leer_consultas(idCaso);
});

$('#md-consultas-de-caso').on('show.bs.modal', function() {
	var idCaso = $('#md-nueva-consulta').data('idcaso');
	leer_consultas(idCaso);
});

function nuevaConsulta () {
	$('#md-consultas-de-caso')
	.modal('hide')
	.on('hidden.bs.modal', function (e) {
		$('#md-nueva-consulta').modal('show');
		$(this).off('hidden.bs.modal');
	});
}

$('#md-nueva-consulta').on('show.bs.modal', function(event) {
	jQuery.ajaxSetup({async: false});

	var idCaso = $('#md-nueva-consulta').data('idcaso');

	$('#consulta-nombres').val('');
	$('#consulta-caso-sinopsis').val('');
	$('#consulta-contenido').val('');
	$('#consulta-materia').val('');
	$('#consulta-tema').val('');
	$('#consulta-tema').get(0).options.length = 0;
	$('#consulta-subtema').val('');
	$('#consulta-subtema').get(0).options.length = 0;
	$('#crespuesta').val('');
	$('#consulta-fecha').val('');
	$('#consulta-idcaso').val('');

	$.ajax({
		url: base_url() + 'consultor/leer-caso',
		type: 'POST',
		dataType: 'json',
		data: {idcaso: idCaso},
	})
	.done(function(response) {
		casoData = response[0];

		$('#consulta-idcaso').val(casoData.idcaso);
		$('#consulta-nombres').val(casoData.apellidop+' '+casoData.apellidom+', '+ casoData.nombres);
		$('#consulta-caso-sinopsis').val(casoData.sinopsis);

		$('#consulta-nombres').prop('disabled', true);
		$('#consulta-caso-sinopsis').prop('disabled', true);
	})
	.fail(function() {
		console.log("error");
	})
	.always(function() {
		console.log("complete");
	});

	jQuery.ajaxSetup({async: true});
});

$("#frm-nueva-consulta").on('submit', function() {
	var formData = $("#frm-nueva-consulta").serializeArray();

	$.ajax({
		url: base_url() + 'consultor/nueva-consulta',
		type: 'POST',
		dataType: 'json',
		data: formData,
	})
	.done(function() {
		bootbox.alert("<h4>Se ha registrado la consulta</h4>",function () {
			$('#md-nueva-consulta')
			.modal('hide')
			.on('hidden.bs.modal', function (e) {
				$('#md-consultas-de-caso').modal('show');
				$(this).off('hidden.bs.modal');
			});	
		});
	})
	.fail(function() {
		console.log("error");
	});

	return false;
});

$('[data-tooltip="tooltip"]').tooltip();